分类 双指针 下的文章

四数之和

问题描述

给定一个包含 n 个整数的数组 nums 和一个目标值 target,判断 nums 中是否存在四个元素 a,b,c 和 d ,使得 a + b + c + d 的值与 target 相等?找出所有满足条件且不重复的四元组。

注意:
答案中不可以包含重复的四元组。

示例:

给定数组 nums = [1, 0, -1, 0, -2, 2],和 target = 0。
满足要求的四元组集合为:
[
  [-1,  0, 0, 1],
  [-2, -1, 1, 2],
  [-2,  0, 0, 2]
]

来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/4sum

思路

和三数之和的思路是一样的,只不过又加了一层循环。
三数之和 https://www.irene.ink/archives/5/

题解

class Solution {
public:
    vector<vector<int>> ret;

    vector<vector<int>> fourSum(vector<int> &nums, int target) {
        int n = nums.size();
        sort(nums.begin(), nums.end());
        if (n < 4) return ret;
        for (int i = 0; i < n - 3; i++) {
            if (i != 0 && nums[i] == nums[i - 1]) continue;
            for (int j = i + 1; j < n - 2; j++) {
                if (j != i + 1 && nums[j] == nums[j - 1]) continue;
                int left = j + 1;
                int right = n - 1;
                while (left < right) {
                    if (nums[i] + nums[j] + nums[left] + nums[right] < target) {
                        left++;
                    } else if (nums[i] + nums[j] + nums[left] + nums[right] > target) {
                        right--;
                    } else{
                        ret.push_back({nums[i],nums[j],nums[left],nums[right]});
                        left++;
                        while (left<right&&nums[left]==nums[left-1]) {
                            left++;
                        }
                    }
                }
            }
        }
        return ret;
    }
};

盛最多水的容器

问题描述

给定 n 个非负整数 a1,a2,...,an,每个数代表坐标中的一个点 (i, ai) 。在坐标内画 n 条垂直线,垂直线 i 的两个端点分别为 (i, ai) 和 (i, 0)。找出其中的两条线,使得它们与 x 轴共同构成的容器可以容纳最多的水。
说明:你不能倾斜容器,且 n 的值至少为 2。
question_11 (1).jpg
图中垂直线代表输入数组 [1,8,6,2,5,4,8,3,7]。在此情况下,容器能够容纳水(表示为蓝色部分)的最大值为 49。

示例:
输入: [1,8,6,2,5,4,8,3,7]
输出: 49

来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/container-with-most-water

思路

容器容纳水的多少,取决于两个方面--两个直线间的距离以及两个直线中比较短的那个高度
本题的思想是双指针:
first=0;last=n-1;因为取决于比较短的那个高度,所以,每次短的那个指针向高的方向移动,来寻求高度的最大值。在这个过程中,直线之间的长度会变小,所以,这就需要在这个高度不断增大,长度不断较小的过程中寻求一个最大的值。

题解

class Solution {
public:
    int maxArea(vector<int>& height) {
        int n=height.size();
        int first=0;
        int last=n-1;
        int smax=0;
      
        while (first<last){
            int sa=min(height[first],height[last])*(last-first);
            if(s>smax){
                smax=s;
            }
            if(height[first]<height[last]){
                first++;
            }
            else if(height[first]>height[last])
            {
                last--;
            } else{
                first++;
            }
        }
        return smax;
    }
};